setwd("~/Desktop/DImmSV/For MS/ADAR/data/raw")
library(bio3d)
library(Biostrings)

# uses consensus seq to block out ADAR  pref site with 5'A/T using majority rule consensus of all seqs

#input data as coding (+'ve sense genome) and rev complement

DImmSV<-read.fasta("DImmSV.fas")
DImmSV_rev_comp<-read.fasta("DImmSV_rev_complement.fas")

mrc<-consensus(DImmSV, cutoff=0.5)
length(mrc$seq)

mrc_rc<-consensus(DImmSV_rev_comp, cutoff=0.5)
length(mrc_rc$seq)

### ADAR edit A->G

### counting pref site as A with 5'A/T ###

### do first for +'ve sense ###

str(mrc)
length(mrc$seq)
result<-as.matrix(mrc$seq)
result2<-as.matrix(mrc$seq)

for (j in 2:1281){
  result[j]<- ifelse(mrc$seq[j]=="A" & (mrc$seq[j-1]=="G" | mrc$seq[j-1]=="C"),"unpref","other")
  result2[j]<- ifelse(mrc$seq[j]=="A" & (mrc$seq[j-1]!="G" & mrc$seq[j-1]!="C"),"pref","other")
}

result
result2

occurence<-as.data.frame(result2)

occurence

### do for -'ve sense (reverse complement of coding) - this means positions will be in rev order to +'ve sense ###

str(mrc_rc)
length(mrc_rc$seq)
result_rc<-as.matrix(mrc_rc$seq)
result2_rc<-as.matrix(mrc_rc$seq)

for (j in 2:1281){
  result_rc[j]<- ifelse(mrc_rc$seq[j]=="A" & (mrc_rc$seq[j-1]=="G" | mrc_rc$seq[j-1]=="C"),"unpref","other")
  result2_rc[j]<- ifelse(mrc_rc$seq[j]=="A" & (mrc_rc$seq[j-1]!="G" & mrc_rc$seq[j-1]!="C"),"pref","other")
}

occurence_rc<-as.data.frame(result2_rc)

occurence_rc

############

#rev order of reverse comp so is just complement
comp<-rev(occurence_rc[,1])
comp

adar<-cbind(occurence,comp)
head(adar)
names(adar)<-c("pos","neg")
adar

table(adar)

out<-as.matrix(DImmSV$ali)

out

#find all prefered sites on + or - strand, and replace with N

for(i in 1:1281){
  out[,i][adar$pos[i] == "pref" | adar$neg[i] == "pref"] <- "N"
}

### look at number of pot' ADAR sites

# number pref and unpref changed to G
table(occurence)
table(occurence_rc)

#num pref ADAR sites
dim(subset(adar,adar$pos == "pref" | adar$neg == "pref"))

dim(adar)

# convert back to single string and export as .fas
out
adar
out1<-as.data.frame(out)
#write.csv(out1,"~/Desktop/DImmSV/DImmSV_ADAR_out_lc.csv")

out2<-apply(out, 1, paste, collapse="")
#write.csv(out2, "~/Desktop/DImmSV/out2_lc.csv")

seqs<- DNAStringSet(out2)

#writeXStringSet(seqs, "~/Desktop/DImmSV/DImmSV_mrc_lc.fasta")



########### look at edited positions


result5<-vector()
result6<-vector()

#do we see

for (j in 2:1281){
  result5[j]<- ifelse("G"%in%DImmSV$ali[,j]&result[j]=="unpref","edit","other")
  result6[j]<- ifelse("G"%in%DImmSV$ali[,j]&result2[j]=="pref","edit","other")
}

#number unpref changed to G
length(which(result5=="edit"))
#number pref changed to G
length(which(result6=="edit"))


#total number unpref 
length(which(result=="unpref"))
#total number pref
length(which(result2=="pref"))

all<-matrix(c(5,9,190,167),nrow=2)
colnames(all) <- c("edit", "no_edit")
rownames(all) <- c("non_pref", "pref")
all
fisher.test(all)

which(result5=="edit")
which(result6=="edit")

#edits (G's) are always minor allele

# 20 seqs reffered to below are 20 seqs all with common set of ADAR edits

table(DImmSV$ali[,159])
#279 in 20/20
table(DImmSV$ali[,279])
table(DImmSV$ali[,348])
table(DImmSV$ali[,483])
# 606, 607, 618, 638 in 20/20
table(DImmSV$ali[,606])
table(DImmSV$ali[,607])
table(DImmSV$ali[,618])
table(DImmSV$ali[,638])
table(DImmSV$ali[,848])

#look at 5' pos for these edits- all A or T
table(DImmSV$ali[,159-1])
table(DImmSV$ali[,279-1])
table(DImmSV$ali[,348-1])
table(DImmSV$ali[,483-1])
table(DImmSV$ali[,606-1])
#pos 607 has 5' A and G as previous A has been edited in some seqs
table(DImmSV$ali[,607-1])
table(DImmSV$ali[,618-1])
table(DImmSV$ali[,638-1])
table(DImmSV$ali[,848-1])


### -'ve sense ###

result5_rc<-vector()
result6_rc<-vector()


for (j in 2:1281){
  result5_rc[j]<- ifelse("G"%in%DImmSV_rev_comp$ali[,j]&result_rc[j]=="unpref","edit","other")
  result6_rc[j]<- ifelse("G"%in%DImmSV_rev_comp$ali[,j]&result2_rc[j]=="pref","edit","other")
}

#number unpref changed to G
length(which(result5_rc=="edit"))
#number pref changed to G
length(which(result6_rc=="edit"))


#total num unpref 
length(which(result_rc=="unpref"))
#total num pref 
length(which(result2_rc=="pref"))

all_rc<-matrix(c(2,8,187,182),nrow=2)
colnames(all_rc) <- c("edit", "no_edit")
rownames(all_rc) <- c("non_pref", "pref")
all_rc
fisher.test(all_rc)

which(result5_rc=="edit")
which(result6_rc=="edit")

#edits (G's) are always minor allele

table(DImmSV_rev_comp$ali[,33])
# 95 in 19/20
table(DImmSV_rev_comp$ali[,95])
table(DImmSV_rev_comp$ali[,657])
table(DImmSV_rev_comp$ali[,859])
table(DImmSV_rev_comp$ali[,874])
table(DImmSV_rev_comp$ali[,913])
table(DImmSV_rev_comp$ali[,957])
table(DImmSV_rev_comp$ali[,1090])

#look at 5' pos for these edits- all A or T
table(DImmSV_rev_comp$ali[,33-1])
table(DImmSV_rev_comp$ali[,95-1])
table(DImmSV_rev_comp$ali[,657-1])
table(DImmSV_rev_comp$ali[,859-1])
table(DImmSV_rev_comp$ali[,874-1])
table(DImmSV_rev_comp$ali[,913-1])
table(DImmSV_rev_comp$ali[,957-1])
table(DImmSV_rev_comp$ali[,1090-1])


### combine data from both + and - strand ###

all
all_rc
all_both<-all+all_rc
all_both
fisher.test(all_both)
chisq.test(all_both)

# sig over rep of edits at ADAR pref sites